"{ Package: 'stx:goodies/metacello/core' }"

MetacelloAbstractPackageSpec subclass:#MetacelloProjectReferenceSpec
	instanceVariableNames:'projectReference'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-Core-Specs'
!


!MetacelloProjectReferenceSpec methodsFor:'accessing'!

answers: aListOfPairs

	self shouldNotImplement
!

includes: aCollection

	self shouldNotImplement
!

projectLabel
    ^ self projectReference projectLabel
!

projectName
	^self projectReference name
!

projectReference: anObject
	projectReference := anObject
!

referencedSpec

	^self projectReference
!

requires: aCollection

	self shouldNotImplement
!

versionString
    ^projectReference versionString

    "Created: / 18-09-2012 / 19:14:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloProjectReferenceSpec methodsFor:'copying'!

postCopy

	super postCopy.
	projectReference := projectReference copy.
! !

!MetacelloProjectReferenceSpec methodsFor:'importing'!

mergeImportLoads: aLoadList
    self projectReference mergeImportLoads: aLoadList
! !

!MetacelloProjectReferenceSpec methodsFor:'loading'!

repositorySpecs

	^self repositories map values
! !

!MetacelloProjectReferenceSpec methodsFor:'merging'!

aboutToCopy
    self projectReference className
!

mergeMap

	| map |
	map := super mergeMap.
	map at: #projectReference put: projectReference.
	^map
!

mergeSpec: anotherSpec

	| newSpec map anotherProjectReference |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherProjectReference := map at: #projectReference) ~~ nil
		ifTrue: [ 
			newSpec projectReference: 
				(newSpec projectReference == nil
					ifTrue: [ anotherProjectReference ]
					ifFalse: [ newSpec projectReference mergeSpec: anotherProjectReference ])].
	^newSpec
!

nonOverridable

	^super nonOverridable, #( projectReference )
! !

!MetacelloProjectReferenceSpec methodsFor:'printing'!

configMethodCascadeOn: aStream member: aMember last: lastCascade indent: indent
    aMember methodUpdateSelector == #'remove:'
        ifTrue: [ aStream nextPutAll: 'removeProject: ' , self name printString ]
        ifFalse: [ 
            self projectReference == nil
                ifTrue: [ ^ self ].
            aStream nextPutAll: self projectLabel , ': ' , self projectName printString , ' '.
            (aMember methodUpdateSelector == #'copy:' and: [ self projectReference hasNonVersionStringField ])
                ifTrue: [ aStream nextPutAll: 'copyFrom: ' , aMember sourceName printString , ' ' ].
            self projectReference configShortCutMethodOn: aStream member: aMember indent: indent + 1 ].
    lastCascade
        ifTrue: [ aStream nextPut: $. ]
        ifFalse: [ 
            aStream
                nextPut: $;;
                cr ]
!

configMethodOn: aStream indent: indent

	aStream 
		tab: indent; nextPutAll: 'spec '; cr;
		tab: indent + 1; nextPutAll: 'name: ', self name printString; nextPut: $;; cr;
		tab: indent + 1; nextPutAll: 'projectReference: '; nextPut: $[; cr.
	aStream 
		tab: indent + 2; nextPutAll: 'spec'.
	self projectReference ifNotNil: [ self projectReference configMethodBodyOn: aStream indent: indent + 2].
	aStream nextPutAll: ' ].'
! !

!MetacelloProjectReferenceSpec methodsFor:'querying'!

projectReference
	^ projectReference
!

relativeCurrentVersion

	^self projectReference relativeCurrentVersion
!

repositories
    ^ self referencedSpec repositories
!

version

	^self projectReference version
!

versionOrNil

	^self projectReference versionOrNil
!

versionString: aString

	^self projectReference versionString: aString
! !

!MetacelloProjectReferenceSpec methodsFor:'testing'!

hasRepository
    ^ self projectReference hasRepository
! !

!MetacelloProjectReferenceSpec methodsFor:'visiting'!

projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	projectBlock value: self
! !

!MetacelloProjectReferenceSpec class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
