"{ Package: 'stx:goodies/metacello/core' }"

MetacelloMethodSpec subclass:#MetacelloSymbolicVersionMethodSpec
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-Core-Constructors'
!


!MetacelloSymbolicVersionMethodSpec methodsFor:'accessing'!

versionString: aStringOrSymbol

	aStringOrSymbol isSymbol ifFalse: [ self error: 'Version symbol ', aStringOrSymbol printString, ' for symbolic version method must be a Symbol' ].
	super versionString: aStringOrSymbol
! !

!MetacelloSymbolicVersionMethodSpec methodsFor:'adding'!

addMethodSection: attribute versionString: aString
	self methodSections
		add:
			((MetacelloSymbolicVersionSpec new)
				attribute: attribute;
				versionString: aString;
				yourself)
! !

!MetacelloSymbolicVersionMethodSpec methodsFor:'method generation'!

methodSource
	| strm |
	strm := WriteStream on: String new.
	self symbolicMethodSelectorAndPragma: self selector symbolicVersionSymbol: self versionString on: strm.
	(self methodSections asArray sort: [ :a :b | a attribute <= b attribute ])
		do: [ :methodSection | 
			| vs |
			strm
				cr;
				tab;
				nextPutAll: 'spec for: #' , methodSection attribute asString printString , ' version: '.
			vs := methodSection versionString.
			vs isSymbol
				ifTrue: [ strm nextPut: $# ].
			strm
				nextPutAll: vs asString printString , '.';
				cr ].
	^ strm contents
!

symbolicMethodSelectorAndPragma: aSelector symbolicVersionSymbol: symbolicVersionSymbol on: strm
	strm
		nextPutAll: aSelector asString , ' spec';
		cr;
		tab;
		nextPutAll: '<symbolicVersion: #' , symbolicVersionSymbol asString printString;
		nextPutAll: '>';
		cr
! !

!MetacelloSymbolicVersionMethodSpec class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
