"{ Package: 'stx:goodies/metacello/core' }"

Error subclass:#MetacelloVersionDoesNotExistError
	instanceVariableNames:'project versionString'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-Core-Exceptions-Errors'
!


!MetacelloVersionDoesNotExistError class methodsFor:'instance creation'!

project: aMetacelloProject versionString: aVersionString

	^(self new)
		project: aMetacelloProject;
		versionString: aVersionString;
		yourself
! !

!MetacelloVersionDoesNotExistError methodsFor:'accessing'!

possibleVersions
    ^ self project symbolicVersionSymbols , (self project versions collect: [ :each | each versionString ])
!

project
	^ project
!

project: anObject
	project := anObject
!

versionString
	^ versionString
!

versionString: anObject
	versionString := anObject
! !

!MetacelloVersionDoesNotExistError methodsFor:'printing'!

description
    "Return a textual description of the exception."

    ^ 'Version ' , self versionString printString , ' is not defined in ' , self project label
        , '. Possible versions include: ' , self possibleVersions printString
! !

!MetacelloVersionDoesNotExistError class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
